~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/scripts/link-vmlinux.sh

Version: ~ [ linux-6.11.5 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.58 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.114 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.169 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.228 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.284 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.322 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.9 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

Diff markup

Differences between /scripts/link-vmlinux.sh (Version linux-6.11.5) and /scripts/link-vmlinux.sh (Version linux-5.9.16)


  1 #!/bin/sh                                           1 #!/bin/sh
  2 # SPDX-License-Identifier: GPL-2.0                  2 # SPDX-License-Identifier: GPL-2.0
  3 #                                                   3 #
  4 # link vmlinux                                      4 # link vmlinux
  5 #                                                   5 #
  6 # vmlinux is linked from the objects in vmlinu !!   6 # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
  7 # vmlinux.a contains objects that are linked u !!   7 # $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
                                                   >>   8 # in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
  8 # $(KBUILD_VMLINUX_LIBS) are archives which ar      9 # $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
  9 # (not within --whole-archive), and do not req     10 # (not within --whole-archive), and do not require symbol indexes added.
 10 #                                                  11 #
 11 # vmlinux                                          12 # vmlinux
 12 #   ^                                              13 #   ^
 13 #   |                                              14 #   |
 14 #   +--< vmlinux.a                             !!  15 #   +--< $(KBUILD_VMLINUX_OBJS)
                                                   >>  16 #   |    +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
 15 #   |                                              17 #   |
 16 #   +--< $(KBUILD_VMLINUX_LIBS)                    18 #   +--< $(KBUILD_VMLINUX_LIBS)
 17 #   |    +--< lib/lib.a + more                     19 #   |    +--< lib/lib.a + more
 18 #   |                                              20 #   |
 19 #   +-< ${kallsymso} (see description in KALLS     21 #   +-< ${kallsymso} (see description in KALLSYMS section)
 20 #                                                  22 #
 21 # vmlinux version (uname -v) cannot be updated     23 # vmlinux version (uname -v) cannot be updated during normal
 22 # descending-into-subdirs phase since we do no     24 # descending-into-subdirs phase since we do not yet know if we need to
 23 # update vmlinux.                                  25 # update vmlinux.
 24 # Therefore this step is delayed until just be     26 # Therefore this step is delayed until just before final link of vmlinux.
 25 #                                                  27 #
 26 # System.map is generated to document addresse     28 # System.map is generated to document addresses of all kernel symbols
 27                                                    29 
 28 # Error out on error                               30 # Error out on error
 29 set -e                                             31 set -e
 30                                                    32 
 31 LD="$1"                                            33 LD="$1"
 32 KBUILD_LDFLAGS="$2"                                34 KBUILD_LDFLAGS="$2"
 33 LDFLAGS_vmlinux="$3"                               35 LDFLAGS_vmlinux="$3"
 34                                                    36 
 35 is_enabled() {                                 << 
 36         grep -q "^$1=y" include/config/auto.co << 
 37 }                                              << 
 38                                                << 
 39 # Nice output in kbuild format                     37 # Nice output in kbuild format
 40 # Will be supressed by "make -s"                   38 # Will be supressed by "make -s"
 41 info()                                             39 info()
 42 {                                                  40 {
 43         printf "  %-7s %s\n" "${1}" "${2}"     !!  41         if [ "${quiet}" != "silent_" ]; then
                                                   >>  42                 printf "  %-7s %s\n" "${1}" "${2}"
                                                   >>  43         fi
                                                   >>  44 }
                                                   >>  45 
                                                   >>  46 # Link of vmlinux.o used for section mismatch analysis
                                                   >>  47 # ${1} output file
                                                   >>  48 modpost_link()
                                                   >>  49 {
                                                   >>  50         local objects
                                                   >>  51 
                                                   >>  52         objects="--whole-archive                                \
                                                   >>  53                 ${KBUILD_VMLINUX_OBJS}                          \
                                                   >>  54                 --no-whole-archive                              \
                                                   >>  55                 --start-group                                   \
                                                   >>  56                 ${KBUILD_VMLINUX_LIBS}                          \
                                                   >>  57                 --end-group"
                                                   >>  58 
                                                   >>  59         ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
                                                   >>  60 }
                                                   >>  61 
                                                   >>  62 objtool_link()
                                                   >>  63 {
                                                   >>  64         local objtoolopt;
                                                   >>  65 
                                                   >>  66         if [ -n "${CONFIG_VMLINUX_VALIDATION}" ]; then
                                                   >>  67                 objtoolopt="check"
                                                   >>  68                 if [ -z "${CONFIG_FRAME_POINTER}" ]; then
                                                   >>  69                         objtoolopt="${objtoolopt} --no-fp"
                                                   >>  70                 fi
                                                   >>  71                 if [ -n "${CONFIG_GCOV_KERNEL}" ]; then
                                                   >>  72                         objtoolopt="${objtoolopt} --no-unreachable"
                                                   >>  73                 fi
                                                   >>  74                 if [ -n "${CONFIG_RETPOLINE}" ]; then
                                                   >>  75                         objtoolopt="${objtoolopt} --retpoline"
                                                   >>  76                 fi
                                                   >>  77                 if [ -n "${CONFIG_X86_SMAP}" ]; then
                                                   >>  78                         objtoolopt="${objtoolopt} --uaccess"
                                                   >>  79                 fi
                                                   >>  80                 info OBJTOOL ${1}
                                                   >>  81                 tools/objtool/objtool ${objtoolopt} ${1}
                                                   >>  82         fi
 44 }                                                  83 }
 45                                                    84 
 46 # Link of vmlinux                                  85 # Link of vmlinux
 47 # ${1} - output file                               86 # ${1} - output file
                                                   >>  87 # ${2}, ${3}, ... - optional extra .o files
 48 vmlinux_link()                                     88 vmlinux_link()
 49 {                                                  89 {
                                                   >>  90         local lds="${objtree}/${KBUILD_LDS}"
 50         local output=${1}                          91         local output=${1}
 51         local objs                             !!  92         local objects
 52         local libs                             !!  93         local strip_debug
 53         local ld                               << 
 54         local ldflags                          << 
 55         local ldlibs                           << 
 56                                                    94 
 57         info LD ${output}                          95         info LD ${output}
 58                                                    96 
 59         # skip output file argument                97         # skip output file argument
 60         shift                                      98         shift
 61                                                    99 
 62         if is_enabled CONFIG_LTO_CLANG || is_e << 
 63                 # Use vmlinux.o instead of per << 
 64                 objs=vmlinux.o                 << 
 65                 libs=                          << 
 66         else                                   << 
 67                 objs=vmlinux.a                 << 
 68                 libs="${KBUILD_VMLINUX_LIBS}"  << 
 69         fi                                     << 
 70                                                << 
 71         if is_enabled CONFIG_MODULES; then     << 
 72                 objs="${objs} .vmlinux.export. << 
 73         fi                                     << 
 74                                                << 
 75         objs="${objs} init/version-timestamp.o << 
 76                                                << 
 77         if [ "${SRCARCH}" = "um" ]; then       << 
 78                 wl=-Wl,                        << 
 79                 ld="${CC}"                     << 
 80                 ldflags="${CFLAGS_vmlinux}"    << 
 81                 ldlibs="-lutil -lrt -lpthread" << 
 82         else                                   << 
 83                 wl=                            << 
 84                 ld="${LD}"                     << 
 85                 ldflags="${KBUILD_LDFLAGS} ${L << 
 86                 ldlibs=                        << 
 87         fi                                     << 
 88                                                << 
 89         ldflags="${ldflags} ${wl}--script=${ob << 
 90                                                << 
 91         # The kallsyms linking does not need d    100         # The kallsyms linking does not need debug symbols included.
 92         if [ -n "${strip_debug}" ] ; then      !! 101         if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
 93                 ldflags="${ldflags} ${wl}--str !! 102                 strip_debug=-Wl,--strip-debug
 94         fi                                        103         fi
 95                                                   104 
 96         if is_enabled CONFIG_VMLINUX_MAP; then !! 105         if [ "${SRCARCH}" != "um" ]; then
 97                 ldflags="${ldflags} ${wl}-Map= !! 106                 objects="--whole-archive                        \
                                                   >> 107                         ${KBUILD_VMLINUX_OBJS}                  \
                                                   >> 108                         --no-whole-archive                      \
                                                   >> 109                         --start-group                           \
                                                   >> 110                         ${KBUILD_VMLINUX_LIBS}                  \
                                                   >> 111                         --end-group                             \
                                                   >> 112                         ${@}"
                                                   >> 113 
                                                   >> 114                 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}      \
                                                   >> 115                         ${strip_debug#-Wl,}                     \
                                                   >> 116                         -o ${output}                            \
                                                   >> 117                         -T ${lds} ${objects}
                                                   >> 118         else
                                                   >> 119                 objects="-Wl,--whole-archive                    \
                                                   >> 120                         ${KBUILD_VMLINUX_OBJS}                  \
                                                   >> 121                         -Wl,--no-whole-archive                  \
                                                   >> 122                         -Wl,--start-group                       \
                                                   >> 123                         ${KBUILD_VMLINUX_LIBS}                  \
                                                   >> 124                         -Wl,--end-group                         \
                                                   >> 125                         ${@}"
                                                   >> 126 
                                                   >> 127                 ${CC} ${CFLAGS_vmlinux}                         \
                                                   >> 128                         ${strip_debug}                          \
                                                   >> 129                         -o ${output}                            \
                                                   >> 130                         -Wl,-T,${lds}                           \
                                                   >> 131                         ${objects}                              \
                                                   >> 132                         -lutil -lrt -lpthread
                                                   >> 133                 rm -f linux
 98         fi                                        134         fi
 99                                                << 
100         ${ld} ${ldflags} -o ${output}          << 
101                 ${wl}--whole-archive ${objs} $ << 
102                 ${wl}--start-group ${libs} ${w << 
103                 ${kallsymso} ${btf_vmlinux_bin << 
104 }                                                 135 }
105                                                   136 
106 # generate .BTF typeinfo from DWARF debuginfo     137 # generate .BTF typeinfo from DWARF debuginfo
107 # ${1} - vmlinux image                            138 # ${1} - vmlinux image
                                                   >> 139 # ${2} - file to dump raw BTF data into
108 gen_btf()                                         140 gen_btf()
109 {                                                 141 {
110         local pahole_ver                          142         local pahole_ver
111         local btf_data=${1}.btf.o              << 
112                                                   143 
113         if ! [ -x "$(command -v ${PAHOLE})" ];    144         if ! [ -x "$(command -v ${PAHOLE})" ]; then
114                 echo >&2 "BTF: ${1}: pahole ($    145                 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
115                 return 1                          146                 return 1
116         fi                                        147         fi
117                                                   148 
118         pahole_ver=$(${PAHOLE} --version | sed    149         pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
119         if [ "${pahole_ver}" -lt "116" ]; then    150         if [ "${pahole_ver}" -lt "116" ]; then
120                 echo >&2 "BTF: ${1}: pahole ve    151                 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
121                 return 1                          152                 return 1
122         fi                                        153         fi
123                                                   154 
124         info BTF "${btf_data}"                 !! 155         vmlinux_link ${1}
125         LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J !! 156 
                                                   >> 157         info "BTF" ${2}
                                                   >> 158         LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
126                                                   159 
127         # Create ${btf_data} which contains ju !! 160         # Create ${2} which contains just .BTF section but no symbols. Add
128         # SHF_ALLOC because .BTF will be part     161         # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
129         # deletes all symbols including __star    162         # deletes all symbols including __start_BTF and __stop_BTF, which will
130         # be redefined in the linker script. A    163         # be redefined in the linker script. Add 2>/dev/null to suppress GNU
131         # objcopy warnings: "empty loadable se    164         # objcopy warnings: "empty loadable segment detected at ..."
132         ${OBJCOPY} --only-section=.BTF --set-s    165         ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
133                 --strip-all ${1} "${btf_data}" !! 166                 --strip-all ${1} ${2} 2>/dev/null
134         # Change e_type to ET_REL so that it c    167         # Change e_type to ET_REL so that it can be used to link final vmlinux.
135         # GNU ld 2.35+ and lld do not allow an !! 168         # Unlike GNU ld, lld does not allow an ET_EXEC input.
136         if is_enabled CONFIG_CPU_BIG_ENDIAN; t !! 169         printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
137                 et_rel='\0\1'                  << 
138         else                                   << 
139                 et_rel='\1\0'                  << 
140         fi                                     << 
141         printf "${et_rel}" | dd of="${btf_data << 
142                                                << 
143         btf_vmlinux_bin_o=${btf_data}          << 
144 }                                                 170 }
145                                                   171 
146 # Create ${2}.o file with all symbols from the !! 172 # Create ${2} .o file with all symbols from the ${1} object file
147 kallsyms()                                        173 kallsyms()
148 {                                                 174 {
                                                   >> 175         info KSYM ${2}
149         local kallsymopt;                         176         local kallsymopt;
150                                                   177 
151         if is_enabled CONFIG_KALLSYMS_ALL; the !! 178         if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
152                 kallsymopt="${kallsymopt} --al    179                 kallsymopt="${kallsymopt} --all-symbols"
153         fi                                        180         fi
154                                                   181 
155         if is_enabled CONFIG_KALLSYMS_ABSOLUTE !! 182         if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
156                 kallsymopt="${kallsymopt} --ab    183                 kallsymopt="${kallsymopt} --absolute-percpu"
157         fi                                        184         fi
158                                                   185 
159         info KSYMS "${2}.S"                    !! 186         if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
160         scripts/kallsyms ${kallsymopt} "${1}"  !! 187                 kallsymopt="${kallsymopt} --base-relative"
                                                   >> 188         fi
                                                   >> 189 
                                                   >> 190         local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL}               \
                                                   >> 191                       ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
161                                                   192 
162         info AS "${2}.o"                       !! 193         local afile="`basename ${2} .o`.S"
163         ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE << 
164               ${KBUILD_AFLAGS} ${KBUILD_AFLAGS << 
165                                                   194 
166         kallsymso=${2}.o                       !! 195         ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
                                                   >> 196         ${CC} ${aflags} -c -o ${2} ${afile}
167 }                                                 197 }
168                                                   198 
169 # Perform kallsyms for the given temporary vml !! 199 # Perform one step in kallsyms generation, including temporary linking of
170 sysmap_and_kallsyms()                          !! 200 # vmlinux.
                                                   >> 201 kallsyms_step()
171 {                                                 202 {
172         mksysmap "${1}" "${1}.syms"            !! 203         kallsymso_prev=${kallsymso}
173         kallsyms "${1}.syms" "${1}.kallsyms"   !! 204         kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
                                                   >> 205         kallsymso=${kallsyms_vmlinux}.o
174                                                   206 
175         kallsyms_sysmap=${1}.syms              !! 207         vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
                                                   >> 208         kallsyms ${kallsyms_vmlinux} ${kallsymso}
176 }                                                 209 }
177                                                   210 
178 # Create map file with all symbols from ${1}      211 # Create map file with all symbols from ${1}
179 # See mksymap for additional details              212 # See mksymap for additional details
180 mksysmap()                                        213 mksysmap()
181 {                                                 214 {
182         info NM ${2}                           !! 215         ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
183         ${NM} -n "${1}" | sed -f "${srctree}/s << 
184 }                                                 216 }
185                                                   217 
186 sorttable()                                       218 sorttable()
187 {                                                 219 {
188         ${objtree}/scripts/sorttable ${1}         220         ${objtree}/scripts/sorttable ${1}
189 }                                                 221 }
190                                                   222 
                                                   >> 223 # Delete output files in case of error
191 cleanup()                                         224 cleanup()
192 {                                                 225 {
193         rm -f .btf.*                              226         rm -f .btf.*
                                                   >> 227         rm -f .tmp_System.map
                                                   >> 228         rm -f .tmp_vmlinux*
194         rm -f System.map                          229         rm -f System.map
195         rm -f vmlinux                             230         rm -f vmlinux
196         rm -f vmlinux.map                      !! 231         rm -f vmlinux.o
                                                   >> 232 }
                                                   >> 233 
                                                   >> 234 on_exit()
                                                   >> 235 {
                                                   >> 236         if [ $? -ne 0 ]; then
                                                   >> 237                 cleanup
                                                   >> 238         fi
                                                   >> 239 }
                                                   >> 240 trap on_exit EXIT
                                                   >> 241 
                                                   >> 242 on_signals()
                                                   >> 243 {
                                                   >> 244         exit 1
197 }                                                 245 }
                                                   >> 246 trap on_signals HUP INT QUIT TERM
198                                                   247 
199 # Use "make V=1" to debug this script             248 # Use "make V=1" to debug this script
200 case "${KBUILD_VERBOSE}" in                       249 case "${KBUILD_VERBOSE}" in
201 *1*)                                              250 *1*)
202         set -x                                    251         set -x
203         ;;                                        252         ;;
204 esac                                              253 esac
205                                                   254 
206 if [ "$1" = "clean" ]; then                       255 if [ "$1" = "clean" ]; then
207         cleanup                                   256         cleanup
208         exit 0                                    257         exit 0
209 fi                                                258 fi
210                                                   259 
211 ${MAKE} -f "${srctree}/scripts/Makefile.build" !! 260 # We need access to CONFIG_ symbols
212                                                !! 261 . include/config/auto.conf
213 btf_vmlinux_bin_o=                             << 
214 kallsymso=                                     << 
215 strip_debug=                                   << 
216                                                << 
217 if is_enabled CONFIG_KALLSYMS; then            << 
218         truncate -s0 .tmp_vmlinux.kallsyms0.sy << 
219         kallsyms .tmp_vmlinux.kallsyms0.syms . << 
220 fi                                             << 
221                                                << 
222 if is_enabled CONFIG_KALLSYMS || is_enabled CO << 
223                                                   262 
224         # The kallsyms linking does not need d !! 263 # Update version
225         if ! is_enabled CONFIG_DEBUG_INFO_BTF; !! 264 info GEN .version
226                 strip_debug=1                  !! 265 if [ -r .version ]; then
227         fi                                     !! 266         VERSION=$(expr 0$(cat .version) + 1)
228                                                !! 267         echo $VERSION > .version
229         vmlinux_link .tmp_vmlinux1             !! 268 else
230 fi                                             !! 269         rm -f .version
231                                                !! 270         echo 1 > .version
232 if is_enabled CONFIG_DEBUG_INFO_BTF; then      !! 271 fi;
233         if ! gen_btf .tmp_vmlinux1; then       !! 272 
                                                   >> 273 # final build of init/
                                                   >> 274 ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
                                                   >> 275 
                                                   >> 276 #link vmlinux.o
                                                   >> 277 info LD vmlinux.o
                                                   >> 278 modpost_link vmlinux.o
                                                   >> 279 objtool_link vmlinux.o
                                                   >> 280 
                                                   >> 281 # modpost vmlinux.o to check for section mismatches
                                                   >> 282 ${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
                                                   >> 283 
                                                   >> 284 info MODINFO modules.builtin.modinfo
                                                   >> 285 ${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
                                                   >> 286 info GEN modules.builtin
                                                   >> 287 # The second line aids cases where multiple modules share the same object.
                                                   >> 288 tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
                                                   >> 289         tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
                                                   >> 290 
                                                   >> 291 btf_vmlinux_bin_o=""
                                                   >> 292 if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
                                                   >> 293         btf_vmlinux_bin_o=.btf.vmlinux.bin.o
                                                   >> 294         if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
234                 echo >&2 "Failed to generate B    295                 echo >&2 "Failed to generate BTF for vmlinux"
235                 echo >&2 "Try to disable CONFI    296                 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
236                 exit 1                            297                 exit 1
237         fi                                        298         fi
238 fi                                                299 fi
239                                                   300 
240 if is_enabled CONFIG_KALLSYMS; then            !! 301 kallsymso=""
                                                   >> 302 kallsymso_prev=""
                                                   >> 303 kallsyms_vmlinux=""
                                                   >> 304 if [ -n "${CONFIG_KALLSYMS}" ]; then
241                                                   305 
242         # kallsyms support                        306         # kallsyms support
243         # Generate section listing all symbols    307         # Generate section listing all symbols and add it into vmlinux
244         # It's a four step process:            !! 308         # It's a three step process:
245         # 0)  Generate a dummy __kallsyms with !! 309         # 1)  Link .tmp_vmlinux1 so it has all symbols and sections,
246         # 1)  Link .tmp_vmlinux.kallsyms1 so i !! 310         #     but __kallsyms is empty.
247         #     with a dummy __kallsyms.         << 
248         #     Running kallsyms on that gives u    311         #     Running kallsyms on that gives us .tmp_kallsyms1.o with
249         #     the right size                      312         #     the right size
250         # 2)  Link .tmp_vmlinux.kallsyms2 so i !! 313         # 2)  Link .tmp_vmlinux2 so it now has a __kallsyms section of
251         #     the right size, but due to the a    314         #     the right size, but due to the added section, some
252         #     addresses have shifted.             315         #     addresses have shifted.
253         #     From here, we generate a correct !! 316         #     From here, we generate a correct .tmp_kallsyms2.o
254         # 3)  That link may have expanded the     317         # 3)  That link may have expanded the kernel image enough that
255         #     more linker branch stubs / tramp    318         #     more linker branch stubs / trampolines had to be added, which
256         #     introduces new names, which furt    319         #     introduces new names, which further expands kallsyms. Do another
257         #     pass if that is the case. In the    320         #     pass if that is the case. In theory it's possible this results
258         #     in even more stubs, but unlikely    321         #     in even more stubs, but unlikely.
259         #     KALLSYMS_EXTRA_PASS=1 may also u    322         #     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
260         #     other bugs.                         323         #     other bugs.
261         # 4)  The correct ${kallsymso} is link    324         # 4)  The correct ${kallsymso} is linked into the final vmlinux.
262         #                                         325         #
263         # a)  Verify that the System.map from     326         # a)  Verify that the System.map from vmlinux matches the map from
264         #     ${kallsymso}.                       327         #     ${kallsymso}.
265                                                   328 
266         # The kallsyms linking does not need d !! 329         kallsyms_step 1
267         strip_debug=1                          !! 330         kallsyms_step 2
268                                                << 
269         sysmap_and_kallsyms .tmp_vmlinux1      << 
270         size1=$(${CONFIG_SHELL} "${srctree}/sc << 
271                                                   331 
272         vmlinux_link .tmp_vmlinux2             !! 332         # step 3
273         sysmap_and_kallsyms .tmp_vmlinux2      !! 333         size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
274         size2=$(${CONFIG_SHELL} "${srctree}/sc    334         size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
275                                                   335 
276         if [ $size1 -ne $size2 ] || [ -n "${KA    336         if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
277                 vmlinux_link .tmp_vmlinux3     !! 337                 kallsyms_step 3
278                 sysmap_and_kallsyms .tmp_vmlin << 
279         fi                                        338         fi
280 fi                                                339 fi
281                                                   340 
282 strip_debug=                                   !! 341 vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
283                                                << 
284 vmlinux_link vmlinux                           << 
285                                                   342 
286 # fill in BTF IDs                                 343 # fill in BTF IDs
287 if is_enabled CONFIG_DEBUG_INFO_BTF && is_enab !! 344 if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
288         info BTFIDS vmlinux                    !! 345 info BTFIDS vmlinux
289         ${RESOLVE_BTFIDS} vmlinux              !! 346 ${RESOLVE_BTFIDS} vmlinux
290 fi                                                347 fi
291                                                   348 
292 mksysmap vmlinux System.map                    !! 349 if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
293                                                << 
294 if is_enabled CONFIG_BUILDTIME_TABLE_SORT; the << 
295         info SORTTAB vmlinux                      350         info SORTTAB vmlinux
296         if ! sorttable vmlinux; then              351         if ! sorttable vmlinux; then
297                 echo >&2 Failed to sort kernel    352                 echo >&2 Failed to sort kernel tables
298                 exit 1                            353                 exit 1
299         fi                                        354         fi
300 fi                                                355 fi
301                                                   356 
                                                   >> 357 info SYSMAP System.map
                                                   >> 358 mksysmap vmlinux System.map
                                                   >> 359 
302 # step a (see comment above)                      360 # step a (see comment above)
303 if is_enabled CONFIG_KALLSYMS; then            !! 361 if [ -n "${CONFIG_KALLSYMS}" ]; then
304         if ! cmp -s System.map "${kallsyms_sys !! 362         mksysmap ${kallsyms_vmlinux} .tmp_System.map
                                                   >> 363 
                                                   >> 364         if ! cmp -s System.map .tmp_System.map; then
305                 echo >&2 Inconsistent kallsyms    365                 echo >&2 Inconsistent kallsyms data
306                 echo >&2 'Try "make KALLSYMS_E !! 366                 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
307                 exit 1                            367                 exit 1
308         fi                                        368         fi
309 fi                                                369 fi
310                                                << 
311 # For fixdep                                   << 
312 echo "vmlinux: $0" > .vmlinux.d                << 
                                                      

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php